package com.parkerriver;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.StringTokenizer;

public class AjaxUtil {

     public static void sendXML(HttpServletResponse response,String body) throws IOException {
        response.setContentType("text/xml; charset=UTF-8");
        response.setHeader("Cache-Control", "no-cache");
        String content = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>"+body;
        response.getWriter().write(content);

    }
     public static void sendText(HttpServletResponse response,String body) throws IOException {
        response.setContentType("text/plain; charset=UTF-8");
        response.setHeader("Cache-Control", "no-cache");
        response.getWriter().write(body);

    }

    public static void sendJson(HttpServletResponse response,String body) throws
            IOException {
        response.setContentType("application/x-json");
        response.setHeader("Cache-Control", "no-cache");
        response.getWriter().write(body);

    }

    public static String getJsonFormat(
                                String propValues, String delim) {
        if(propValues == null || propValues.length()==0) { return "";}

        StringBuffer structure = new StringBuffer("");
        structure.append("{\n");
        if (delim == null || delim.length() == 0) { delim = ",";}
         /* We're expecting comma-separated values such as prop1,val1,prop2,val2 etc. */
        StringTokenizer toke = new StringTokenizer(propValues,delim);
        int j = 0;
        int c =  toke.countTokens();
         for(int i = 1; i <=c; i++) {
            j = i%2;
            if(j != 0) { structure.append(toke.nextToken()).append(": ");   }//it's a property name
            else { structure.append("\"").append(toke.nextToken()).append("\""); //it's a property value
                if(i != c){structure.append(",");}
                structure.append("\n");
            }
        }
        structure.append("}");
        return structure.toString();

    }

    public static String getJsonArray(String[] strArr)  {
        if(strArr == null || strArr.length == 0) { return ""; }
        StringBuffer structure = new StringBuffer("");
        structure.append("[");
         /* We're expecting an array of Strings */
       for(int i = 0; i < strArr.length; i++)  {
          if(i !=  strArr.length-1) {structure.append("\"").append(strArr[i]).append("\",");
          } else {structure.append("\"").append(strArr[i]).append("\""); }
       }
        structure.append("]");
        return structure.toString();

    }
}
