package com.parkerriver;

import java.io.IOException;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.URL;
import java.net.HttpURLConnection;
import java.net.ProtocolException;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Collections;

import org.jdom.*;
import org.jdom.input.*;

/**
 * Created by IntelliJ IDEA.
 * User: bruceperry
 * Date: Jan 3, 2006
 * Time: 9:07:55 AM
 * To change this template use File | Settings | File Templates.
 */
public class WeatherManager {
    private static String weatherSearch = "http://xoap.weather.com/weather/local/";
    private static String addressSearch = "http://xoap.weather.com/search/search?where=";
    private static String partId = "1012144868";
    private static String licId = "67f74aa9fd9cc0e2";
    private static Map locationIds = Collections.synchronizedMap(new HashMap());
    private static String[] cityList = {"Seattle, WA", "Portland, OR",
            "Boston, MA", "Boulder, CO"};

    /*     http://xoap.weather.com/weather/local/30066?cc=*&dayf=2&prod=xoap&par=partId&key=licId*/
    static {
        try {
            initLocationIds(cityList, locationIds);
        } catch (IOException e) {
            e.printStackTrace();
        } catch (JDOMException e) {
            e.printStackTrace();
        }
    }

    private static void initLocationIds(String[] list, Map map) throws IOException, JDOMException {
        for (int i = 0; i < list.length; i++) {
            map.put(list[i], getLocationId(list[i]));
        }

    }

    private static String getLocationId(String _city) throws IOException, JDOMException {
        String url = addressSearch + java.net.URLEncoder.encode(_city, "UTF-8");
        URL wcomUrl = new URL(url);

        HttpURLConnection htUrl = (HttpURLConnection) wcomUrl.openConnection();
        htUrl.setDoInput(true);
        htUrl.setRequestMethod("GET");
        BufferedReader in = new BufferedReader(
                new InputStreamReader(
                        htUrl.getInputStream()));
        //use the JDom API
        SAXBuilder builder = new SAXBuilder();
        Document doc = builder.build(in);
        Element loc = doc.getRootElement().getChild("loc");
        return loc.getAttributeValue("id");
    }

    public static Map getDailyWeather(String _city) throws IOException,
            ProtocolException, JDOMException {
        String locId = (String) locationIds.get(_city);
        //System.out.println("locId = " + locId);
        String url = new StringBuffer(weatherSearch).append(locId).
                append("?cc=*&dayf=2&prod=xoap&par=").
                append(partId).append("&key=").append(licId).toString();
        URL wcomUrl = new URL(url);

        HttpURLConnection htUrl = (HttpURLConnection) wcomUrl.openConnection();
        htUrl.setDoInput(true);
        htUrl.setRequestMethod("GET");
        BufferedReader in = new BufferedReader(
                new InputStreamReader(
                        htUrl.getInputStream()));
        //use the JDom API
        SAXBuilder builder = new SAXBuilder();
        Document doc = builder.build(in);
        Element root = doc.getRootElement();
        Map _map = new HashMap();
        //Create a HashMap with keys: id="portland", hi=hi, lo=lo, img=icon
        _map.put("id", _city.split(", ")[0].toLowerCase());
        _map.put("hi", root.getChild("dayf").getChild("day").getChildText("hi"));
        _map.put("low", root.getChild("dayf").getChild("day").getChildText("low"));
        _map.put("date", root.getChild("dayf").getChildText("lsup"));
        List _l = root.getChild("dayf").getChild("day").getChildren("part");
        Element el_;
        for (Iterator iter = _l.iterator(); iter.hasNext();) {
            el_ = (Element) iter.next();
            if (el_.getAttributeValue("p").equalsIgnoreCase("d")) {
                _map.put("img", el_.getChildText("icon"));
                _map.put("desc", el_.getChildText("t"));
            }
        }

        return _map;
    }

    public static Map[] getAllWeather() throws IOException,
            JDOMException {
        Map[] map = new HashMap[cityList.length];
        for (int i = 0; i < cityList.length; i++) {
            map[i] =  getDailyWeather(cityList[i]);
        }
        return map;
    }

    public static void main(String[] args) throws IOException, JDOMException {
       /* for (int i = 0; i < cityList.length; i++) {
            Map map = getDailyWeather(cityList[i]);
            Iterator iter = map.keySet().iterator();
            String key;
            String value;
            while (iter.hasNext()) {
                key = (String) iter.next();
                System.out.println("key = " + key);
                value = (String) map.get(key);
                System.out.println("value = " + value);
            }
        }  */
        Map[] map = getAllWeather();
        System.out.println("map.length = " + map.length);
    }
}
